diff --git a/NetworkPkg/Ip6Dxe/Ip6Nd.c b/NetworkPkg/Ip6Dxe/Ip6Nd.c
index 0780a98..c10c701 100644
--- a/NetworkPkg/Ip6Dxe/Ip6Nd.c
+++ b/NetworkPkg/Ip6Dxe/Ip6Nd.c
@@ -2098,262 +2105,266 @@ Ip6ProcessRouterAdvertise (
   // fit within the input packet.
   //
   Offset = 16;
-  while (Offset < (UINT32) Head->PayloadLength) {
+  while (Offset < (UINT32)Head->PayloadLength) {
     NetbufCopy (Packet, Offset, sizeof (UINT8), &Type);
     switch (Type) {
-    case Ip6OptionEtherSource:
-      //
-      // Update the neighbor cache
-      //
-      NetbufCopy (Packet, Offset, sizeof (IP6_ETHER_ADDR_OPTION), (UINT8 *) &LinkLayerOption);
+      case Ip6OptionEtherSource:
+        //
+        // Update the neighbor cache
+        //
+        NetbufCopy (Packet, Offset, sizeof (IP6_ETHER_ADDR_OPTION), (UINT8 *)&LinkLayerOption);
 
-      //
-      // Option size validity ensured by Ip6IsNDOptionValid().
-      //
-      ASSERT (LinkLayerOption.Length != 0);
-      ASSERT (Offset + (UINT32) LinkLayerOption.Length * 8 <= (UINT32) Head->PayloadLength);
+        //
+        // Option size validity ensured by Ip6IsNDOptionValid().
+        //
+        ASSERT (LinkLayerOption.Length != 0);
+        ASSERT (Offset + (UINT32)LinkLayerOption.Length * 8 <= (UINT32)Head->PayloadLength);
 
-      ZeroMem (&LinkLayerAddress, sizeof (EFI_MAC_ADDRESS));
-      CopyMem (&LinkLayerAddress, LinkLayerOption.EtherAddr, 6);
+        ZeroMem (&LinkLayerAddress, sizeof (EFI_MAC_ADDRESS));
+        CopyMem (&LinkLayerAddress, LinkLayerOption.EtherAddr, 6);
 
-      if (NeighborCache == NULL) {
-        NeighborCache = Ip6CreateNeighborEntry (
-                          IpSb,
-                          Ip6OnArpResolved,
-                          &Head->SourceAddress,
-                          &LinkLayerAddress
-                          );
         if (NeighborCache == NULL) {
-          Status = EFI_OUT_OF_RESOURCES;
-          goto Exit;
+          NeighborCache = Ip6CreateNeighborEntry (
+                            IpSb,
+                            Ip6OnArpResolved,
+                            &Head->SourceAddress,
+                            &LinkLayerAddress
+                            );
+          if (NeighborCache == NULL) {
+            Status = EFI_OUT_OF_RESOURCES;
+            goto Exit;
+          }
+
+          NeighborCache->IsRouter = TRUE;
+          NeighborCache->State    = EfiNeighborStale;
+          NeighborCache->Ticks    = (UINT32)IP6_INFINIT_LIFETIME;
+        } else {
+          Result = CompareMem (&LinkLayerAddress, &NeighborCache->LinkAddress, 6);
+
+          //
+          // If the link-local address is the same as that already in the cache,
+          // the cache entry's state remains unchanged. Otherwise update the
+          // reachability state to STALE.
+          //
+          if ((NeighborCache->State == EfiNeighborInComplete) || (Result != 0)) {
+            CopyMem (&NeighborCache->LinkAddress, &LinkLayerAddress, 6);
+
+            NeighborCache->Ticks = (UINT32)IP6_INFINIT_LIFETIME;
+
+            if (NeighborCache->State == EfiNeighborInComplete) {
+              //
+              // Send queued packets if exist.
+              //
+              NeighborCache->State = EfiNeighborStale;
+              NeighborCache->CallBack ((VOID *)NeighborCache);
+            } else {
+              NeighborCache->State = EfiNeighborStale;
+            }
+          }
         }
-        NeighborCache->IsRouter = TRUE;
-        NeighborCache->State    = EfiNeighborStale;
-        NeighborCache->Ticks    = (UINT32) IP6_INFINIT_LIFETIME;
-      } else {
-        Result = CompareMem (&LinkLayerAddress, &NeighborCache->LinkAddress, 6);
+
+        Offset += (UINT32)LinkLayerOption.Length * 8;
+        break;
+      case Ip6OptionPrefixInfo:
+        NetbufCopy (Packet, Offset, sizeof (IP6_PREFIX_INFO_OPTION), (UINT8 *)&PrefixOption);
 
         //
-        // If the link-local address is the same as that already in the cache,
-        // the cache entry's state remains unchanged. Otherwise update the
-        // reachability state to STALE.
+        // Option size validity ensured by Ip6IsNDOptionValid().
         //
-        if ((NeighborCache->State == EfiNeighborInComplete) || (Result != 0)) {
-          CopyMem (&NeighborCache->LinkAddress, &LinkLayerAddress, 6);
+        ASSERT (PrefixOption.Length == 4);
+        ASSERT (Offset + (UINT32)PrefixOption.Length * 8 <= (UINT32)Head->PayloadLength);
 
-          NeighborCache->Ticks = (UINT32) IP6_INFINIT_LIFETIME;
+        PrefixOption.ValidLifetime     = NTOHL (PrefixOption.ValidLifetime);
+        PrefixOption.PreferredLifetime = NTOHL (PrefixOption.PreferredLifetime);
 
-          if (NeighborCache->State == EfiNeighborInComplete) {
-            //
-            // Send queued packets if exist.
-            //
-            NeighborCache->State = EfiNeighborStale;
-            NeighborCache->CallBack ((VOID *) NeighborCache);
-          } else {
-            NeighborCache->State = EfiNeighborStale;
-          }
+        //
+        // Get L and A flag, recorded in the lower 2 bits of Reserved1
+        //
+        OnLink = FALSE;
+        if ((PrefixOption.Reserved1 & IP6_ON_LINK_FLAG) == IP6_ON_LINK_FLAG) {
+          OnLink = TRUE;
         }
-      }
-
-      Offset += (UINT32) LinkLayerOption.Length * 8;
-      break;
-    case Ip6OptionPrefixInfo:
-      NetbufCopy (Packet, Offset, sizeof (IP6_PREFIX_INFO_OPTION), (UINT8 *) &PrefixOption);
 
-      //
-      // Option size validity ensured by Ip6IsNDOptionValid().
-      //
-      ASSERT (PrefixOption.Length == 4);
-      ASSERT (Offset + (UINT32) PrefixOption.Length * 8 <= (UINT32) Head->PayloadLength);
-
-      PrefixOption.ValidLifetime     = NTOHL (PrefixOption.ValidLifetime);
-      PrefixOption.PreferredLifetime = NTOHL (PrefixOption.PreferredLifetime);
+        Autonomous = FALSE;
+        if ((PrefixOption.Reserved1 & IP6_AUTO_CONFIG_FLAG) == IP6_AUTO_CONFIG_FLAG) {
+          Autonomous = TRUE;
+        }
 
-      //
-      // Get L and A flag, recorded in the lower 2 bits of Reserved1
-      //
-      OnLink = FALSE;
-      if ((PrefixOption.Reserved1 & IP6_ON_LINK_FLAG) == IP6_ON_LINK_FLAG) {
-        OnLink = TRUE;
-      }
-      Autonomous = FALSE;
-      if ((PrefixOption.Reserved1 & IP6_AUTO_CONFIG_FLAG) == IP6_AUTO_CONFIG_FLAG) {
-        Autonomous = TRUE;
-      }
+        //
+        // If the prefix is the link-local prefix, silently ignore the prefix option.
+        //
+        if ((PrefixOption.PrefixLength == IP6_LINK_LOCAL_PREFIX_LENGTH) &&
+            NetIp6IsLinkLocalAddr (&PrefixOption.Prefix)
+            )
+        {
+          Offset += sizeof (IP6_PREFIX_INFO_OPTION);
+          break;
+        }
 
-      //
-      // If the prefix is the link-local prefix, silently ignore the prefix option.
-      //
-      if (PrefixOption.PrefixLength == IP6_LINK_LOCAL_PREFIX_LENGTH &&
-          NetIp6IsLinkLocalAddr (&PrefixOption.Prefix)
-          ) {
-        Offset += sizeof (IP6_PREFIX_INFO_OPTION);
-        break;
-      }
-      //
-      // Do following if on-link flag is set according to RFC4861.
-      //
-      if (OnLink) {
-        PrefixList = Ip6FindPrefixListEntry (
-                       IpSb,
-                       TRUE,
-                       PrefixOption.PrefixLength,
-                       &PrefixOption.Prefix
-                       );
         //
-        // Create a new entry for the prefix, if the ValidLifetime is zero,
-        // silently ignore the prefix option.
+        // Do following if on-link flag is set according to RFC4861.
         //
-        if (PrefixList == NULL && PrefixOption.ValidLifetime != 0) {
-          PrefixList = Ip6CreatePrefixListEntry (
+        if (OnLink) {
+          PrefixList = Ip6FindPrefixListEntry (
                          IpSb,
                          TRUE,
-                         PrefixOption.ValidLifetime,
-                         PrefixOption.PreferredLifetime,
                          PrefixOption.PrefixLength,
                          &PrefixOption.Prefix
                          );
-          if (PrefixList == NULL) {
-            Status = EFI_OUT_OF_RESOURCES;
-            goto Exit;
-          }
-        } else if (PrefixList != NULL) {
-          if (PrefixOption.ValidLifetime != 0) {
-            PrefixList->ValidLifetime = PrefixOption.ValidLifetime;
-          } else {
-            //
-            // If the prefix exists and incoming ValidLifetime is zero, immediately
-            // remove the prefix.
-            Ip6DestroyPrefixListEntry (IpSb, PrefixList, OnLink, TRUE);
-          }
-        }
-      }
-
-      //
-      // Do following if Autonomous flag is set according to RFC4862.
-      //
-      if (Autonomous && PrefixOption.PreferredLifetime <= PrefixOption.ValidLifetime) {
-        PrefixList = Ip6FindPrefixListEntry (
-                       IpSb,
-                       FALSE,
-                       PrefixOption.PrefixLength,
-                       &PrefixOption.Prefix
-                       );
-        //
-        // Create a new entry for the prefix, and form an address by prefix + interface id
-        // If the sum of the prefix length and interface identifier length
-        // does not equal 128 bits, the Prefix Information option MUST be ignored.
-        //
-        if (PrefixList == NULL &&
-            PrefixOption.ValidLifetime != 0 &&
-            PrefixOption.PrefixLength + IpSb->InterfaceIdLen * 8 == 128
-            ) {
           //
-          // Form the address in network order.
+          // Create a new entry for the prefix, if the ValidLifetime is zero,
+          // silently ignore the prefix option.
           //
-          CopyMem (&StatelessAddress, &PrefixOption.Prefix, sizeof (UINT64));
-          CopyMem (&StatelessAddress.Addr[8], IpSb->InterfaceId, sizeof (UINT64));
-
-          //
-          // If the address is not yet in the assigned address list, adds it into.
-          //
-          if (!Ip6IsOneOfSetAddress (IpSb, &StatelessAddress, NULL, NULL)) {
-            //
-            // And also not in the DAD process, check its uniqueness firstly.
-            //
-            if (Ip6FindDADEntry (IpSb, &StatelessAddress, NULL) == NULL) {
-              Status = Ip6SetAddress (
-                         IpSb->DefaultInterface,
-                         &StatelessAddress,
-                         FALSE,
-                         PrefixOption.PrefixLength,
-                         PrefixOption.ValidLifetime,
-                         PrefixOption.PreferredLifetime,
-                         NULL,
-                         NULL
-                         );
-              if (EFI_ERROR (Status)) {
-                goto Exit;
-              }
+          if ((PrefixList == NULL) && (PrefixOption.ValidLifetime != 0)) {
+            PrefixList = Ip6CreatePrefixListEntry (
+                           IpSb,
+                           TRUE,
+                           PrefixOption.ValidLifetime,
+                           PrefixOption.PreferredLifetime,
+                           PrefixOption.PrefixLength,
+                           &PrefixOption.Prefix
+                           );
+            if (PrefixList == NULL) {
+              Status = EFI_OUT_OF_RESOURCES;
+              goto Exit;
+            }
+          } else if (PrefixList != NULL) {
+            if (PrefixOption.ValidLifetime != 0) {
+              PrefixList->ValidLifetime = PrefixOption.ValidLifetime;
+            } else {
+              //
+              // If the prefix exists and incoming ValidLifetime is zero, immediately
+              // remove the prefix.
+              Ip6DestroyPrefixListEntry (IpSb, PrefixList, OnLink, TRUE);
             }
           }
+        }
 
-          //
-          // Adds the prefix option to stateless prefix option list.
-          //
-          PrefixList = Ip6CreatePrefixListEntry (
+        //
+        // Do following if Autonomous flag is set according to RFC4862.
+        //
+        if (Autonomous && (PrefixOption.PreferredLifetime <= PrefixOption.ValidLifetime)) {
+          PrefixList = Ip6FindPrefixListEntry (
                          IpSb,
                          FALSE,
-                         PrefixOption.ValidLifetime,
-                         PrefixOption.PreferredLifetime,
                          PrefixOption.PrefixLength,
                          &PrefixOption.Prefix
                          );
-          if (PrefixList == NULL) {
-            Status = EFI_OUT_OF_RESOURCES;
-            goto Exit;
-          }
-        } else if (PrefixList != NULL) {
-
           //
-          // Reset the preferred lifetime of the address if the advertised prefix exists.
-          // Perform specific action to valid lifetime together.
+          // Create a new entry for the prefix, and form an address by prefix + interface id
+          // If the sum of the prefix length and interface identifier length
+          // does not equal 128 bits, the Prefix Information option MUST be ignored.
           //
-          PrefixList->PreferredLifetime = PrefixOption.PreferredLifetime;
-          if ((PrefixOption.ValidLifetime > 7200) ||
-              (PrefixOption.ValidLifetime > PrefixList->ValidLifetime)) {
+          if ((PrefixList == NULL) &&
+              (PrefixOption.ValidLifetime != 0) &&
+              (PrefixOption.PrefixLength + IpSb->InterfaceIdLen * 8 == 128)
+              )
+          {
             //
-            // If the received Valid Lifetime is greater than 2 hours or
-            // greater than RemainingLifetime, set the valid lifetime of the
-            // corresponding address to the advertised Valid Lifetime.
+            // Form the address in network order.
             //
-            PrefixList->ValidLifetime = PrefixOption.ValidLifetime;
+            CopyMem (&StatelessAddress, &PrefixOption.Prefix, sizeof (UINT64));
+            CopyMem (&StatelessAddress.Addr[8], IpSb->InterfaceId, sizeof (UINT64));
 
-          } else if (PrefixList->ValidLifetime <= 7200) {
             //
-            // If RemainingLifetime is less than or equals to 2 hours, ignore the
-            // Prefix Information option with regards to the valid lifetime.
-            // TODO: If this option has been authenticated, set the valid lifetime.
+            // If the address is not yet in the assigned address list, adds it into.
             //
-          } else {
+            if (!Ip6IsOneOfSetAddress (IpSb, &StatelessAddress, NULL, NULL)) {
+              //
+              // And also not in the DAD process, check its uniqueness firstly.
+              //
+              if (Ip6FindDADEntry (IpSb, &StatelessAddress, NULL) == NULL) {
+                Status = Ip6SetAddress (
+                           IpSb->DefaultInterface,
+                           &StatelessAddress,
+                           FALSE,
+                           PrefixOption.PrefixLength,
+                           PrefixOption.ValidLifetime,
+                           PrefixOption.PreferredLifetime,
+                           NULL,
+                           NULL
+                           );
+                if (EFI_ERROR (Status)) {
+                  goto Exit;
+                }
+              }
+            }
+
             //
-            // Otherwise, reset the valid lifetime of the corresponding
-            // address to 2 hours.
+            // Adds the prefix option to stateless prefix option list.
+            //
+            PrefixList = Ip6CreatePrefixListEntry (
+                           IpSb,
+                           FALSE,
+                           PrefixOption.ValidLifetime,
+                           PrefixOption.PreferredLifetime,
+                           PrefixOption.PrefixLength,
+                           &PrefixOption.Prefix
+                           );
+            if (PrefixList == NULL) {
+              Status = EFI_OUT_OF_RESOURCES;
+              goto Exit;
+            }
+          } else if (PrefixList != NULL) {
             //
-            PrefixList->ValidLifetime = 7200;
+            // Reset the preferred lifetime of the address if the advertised prefix exists.
+            // Perform specific action to valid lifetime together.
+            //
+            PrefixList->PreferredLifetime = PrefixOption.PreferredLifetime;
+            if ((PrefixOption.ValidLifetime > 7200) ||
+                (PrefixOption.ValidLifetime > PrefixList->ValidLifetime))
+            {
+              //
+              // If the received Valid Lifetime is greater than 2 hours or
+              // greater than RemainingLifetime, set the valid lifetime of the
+              // corresponding address to the advertised Valid Lifetime.
+              //
+              PrefixList->ValidLifetime = PrefixOption.ValidLifetime;
+            } else if (PrefixList->ValidLifetime <= 7200) {
+              //
+              // If RemainingLifetime is less than or equals to 2 hours, ignore the
+              // Prefix Information option with regards to the valid lifetime.
+              // TODO: If this option has been authenticated, set the valid lifetime.
+              //
+            } else {
+              //
+              // Otherwise, reset the valid lifetime of the corresponding
+              // address to 2 hours.
+              //
+              PrefixList->ValidLifetime = 7200;
+            }
           }
         }
-      }
 
-      Offset += sizeof (IP6_PREFIX_INFO_OPTION);
-      break;
-    case Ip6OptionMtu:
-      NetbufCopy (Packet, Offset, sizeof (IP6_MTU_OPTION), (UINT8 *) &MTUOption);
+        Offset += sizeof (IP6_PREFIX_INFO_OPTION);
+        break;
+      case Ip6OptionMtu:
+        NetbufCopy (Packet, Offset, sizeof (IP6_MTU_OPTION), (UINT8 *)&MTUOption);
 
-      //
-      // Option size validity ensured by Ip6IsNDOptionValid().
-      //
-      ASSERT (MTUOption.Length == 1);
-      ASSERT (Offset + (UINT32) MTUOption.Length * 8 <= (UINT32) Head->PayloadLength);
+        //
+        // Option size validity ensured by Ip6IsNDOptionValid().
+        //
+        ASSERT (MTUOption.Length == 1);
+        ASSERT (Offset + (UINT32)MTUOption.Length * 8 <= (UINT32)Head->PayloadLength);
 
-      //
-      // Use IPv6 minimum link MTU 1280 bytes as the maximum packet size in order
-      // to omit implementation of Path MTU Discovery. Thus ignore the MTU option
-      // in Router Advertisement.
-      //
+        //
+        // Use IPv6 minimum link MTU 1280 bytes as the maximum packet size in order
+        // to omit implementation of Path MTU Discovery. Thus ignore the MTU option
+        // in Router Advertisement.
+        //
 
-      Offset += sizeof (IP6_MTU_OPTION);
-      break;
-    default:
-      //
-      // Silently ignore unrecognized options
-      //
-      NetbufCopy (Packet, Offset + sizeof (UINT8), sizeof (UINT8), &Length);
+        Offset += sizeof (IP6_MTU_OPTION);
+        break;
+      default:
+        //
+        // Silently ignore unrecognized options
+        //
+        NetbufCopy (Packet, Offset + sizeof (UINT8), sizeof (UINT8), &Length);
 
-      ASSERT (Length != 0);
+        ASSERT (Length != 0);
 
-      Offset += (UINT32) Length * 8;
-      break;
+        Offset += (UINT32)Length * 8;
+        break;
     }
   }
 
@@ -2382,31 +2393,31 @@ Exit:
 **/
 EFI_STATUS
 Ip6ProcessRedirect (
-  IN IP6_SERVICE            *IpSb,
-  IN EFI_IP6_HEADER         *Head,
-  IN NET_BUF                *Packet
+  IN IP6_SERVICE     *IpSb,
+  IN EFI_IP6_HEADER  *Head,
+  IN NET_BUF         *Packet
   )
 {
-  IP6_ICMP_INFORMATION_HEAD *Icmp;
-  EFI_IPv6_ADDRESS          *Target;
-  EFI_IPv6_ADDRESS          *IcmpDest;
-  UINT8                     *Option;
-  UINT16                    OptionLen;
-  IP6_ROUTE_ENTRY           *RouteEntry;
-  IP6_ROUTE_CACHE_ENTRY     *RouteCache;
-  IP6_NEIGHBOR_ENTRY        *NeighborCache;
-  INT32                     Length;
-  UINT8                     OptLen;
-  IP6_ETHER_ADDR_OPTION     *LinkLayerOption;
-  EFI_MAC_ADDRESS           Mac;
-  UINT32                    Index;
-  BOOLEAN                   IsRouter;
-  EFI_STATUS                Status;
-  INTN                      Result;
+  IP6_ICMP_INFORMATION_HEAD  *Icmp;
+  EFI_IPv6_ADDRESS           *Target;
+  EFI_IPv6_ADDRESS           *IcmpDest;
+  UINT8                      *Option;
+  UINT16                     OptionLen;
+  IP6_ROUTE_ENTRY            *RouteEntry;
+  IP6_ROUTE_CACHE_ENTRY      *RouteCache;
+  IP6_NEIGHBOR_ENTRY         *NeighborCache;
+  INT32                      Length;
+  UINT8                      OptLen;
+  IP6_ETHER_ADDR_OPTION      *LinkLayerOption;
+  EFI_MAC_ADDRESS            Mac;
+  UINT32                     Index;
+  BOOLEAN                    IsRouter;
+  EFI_STATUS                 Status;
+  INTN                       Result;
 
   Status = EFI_INVALID_PARAMETER;
 
-  Icmp = (IP6_ICMP_INFORMATION_HEAD *) NetbufGetByte (Packet, 0, NULL);
+  Icmp = (IP6_ICMP_INFORMATION_HEAD *)NetbufGetByte (Packet, 0, NULL);
   if (Icmp == NULL) {
     goto Exit;
   }
@@ -2421,8 +2432,9 @@ Ip6ProcessRedirect (
   // ICMP Code is 0.
   // ICMP length (derived from the IP length) is 40 or more octets.
   //
-  if (Head->HopLimit != IP6_HOP_LIMIT || Icmp->Head.Code != 0 ||
-      Head->PayloadLength < IP6_REDITECT_LENGTH) {
+  if ((Head->HopLimit != IP6_HOP_LIMIT) || (Icmp->Head.Code != 0) ||
+      (Head->PayloadLength < IP6_REDITECT_LENGTH))
+  {
     goto Exit;
   }
 
@@ -2443,9 +2455,9 @@ Ip6ProcessRedirect (
   //
   // All included options have a length that is greater than zero.
   //
-  OptionLen = (UINT16) (Head->PayloadLength - IP6_REDITECT_LENGTH);
+  OptionLen = (UINT16)(Head->PayloadLength - IP6_REDITECT_LENGTH);
   if (OptionLen != 0) {
-    Option    = NetbufGetByte (Packet, IP6_REDITECT_LENGTH, NULL);
+    Option = NetbufGetByte (Packet, IP6_REDITECT_LENGTH, NULL);
     ASSERT (Option != NULL);
 
     if (!Ip6IsNDOptionValid (Option, OptionLen)) {
@@ -2453,7 +2465,7 @@ Ip6ProcessRedirect (
     }
   }
 
-  Target   = (EFI_IPv6_ADDRESS *) (Icmp + 1);
+  Target   = (EFI_IPv6_ADDRESS *)(Icmp + 1);
   IcmpDest = Target + 1;
 
   //
@@ -2479,32 +2491,34 @@ Ip6ProcessRedirect (
   // address option.
   //
   Length          = Packet->TotalSize - 40;
-  Option          = (UINT8 *) (IcmpDest + 1);
+  Option          = (UINT8 *)(IcmpDest + 1);
   LinkLayerOption = NULL;
   while (Length > 0) {
     switch (*Option) {
-    case Ip6OptionEtherTarget:
+      case Ip6OptionEtherTarget:
 
-      LinkLayerOption = (IP6_ETHER_ADDR_OPTION *) Option;
-      OptLen          = LinkLayerOption->Length;
-      if (OptLen != 1) {
-        //
-        // For ethernet, the length must be 1.
-        //
-        goto Exit;
-      }
-      break;
+        LinkLayerOption = (IP6_ETHER_ADDR_OPTION *)Option;
+        OptLen          = LinkLayerOption->Length;
+        if (OptLen != 1) {
+          //
+          // For ethernet, the length must be 1.
+          //
+          goto Exit;
+        }
 
-    default:
+        break;
 
-      OptLen = *(Option + 1);
-      if (OptLen == 0) {
-        //
-        // A length of 0 is invalid.
-        //
-        goto Exit;
-      }
-      break;
+      default:
+
+        OptLen = *(Option + 1);
+        if (OptLen == 0) {
+          //
+          // A length of 0 is invalid.
+          //
+          goto Exit;
+        }
+
+        break;
     }
 
     Length -= 8 * OptLen;
@@ -2535,10 +2549,9 @@ Ip6ProcessRedirect (
     IP6_COPY_ADDRESS (&RouteCache->NextHop, Target);
 
     if (!IsRouter) {
-      RouteEntry = (IP6_ROUTE_ENTRY *) RouteCache->Tag;
+      RouteEntry       = (IP6_ROUTE_ENTRY *)RouteCache->Tag;
       RouteEntry->Flag = RouteEntry->Flag | IP6_DIRECT_ROUTE;
     }
-
   } else {
     //
     // Get the Route Entry.
@@ -2563,7 +2576,7 @@ Ip6ProcessRedirect (
                    IcmpDest,
                    &Head->DestinationAddress,
                    Target,
-                   (UINTN) RouteEntry
+                   (UINTN)RouteEntry
                    );
     if (RouteCache == NULL) {
       Status = EFI_OUT_OF_RESOURCES;
@@ -2600,7 +2613,7 @@ Ip6ProcessRedirect (
       }
 
       NeighborCache->State = EfiNeighborStale;
-      NeighborCache->Ticks = (UINT32) IP6_INFINIT_LIFETIME;
+      NeighborCache->Ticks = (UINT32)IP6_INFINIT_LIFETIME;
     } else {
       Result = CompareMem (LinkLayerOption->EtherAddr, &NeighborCache->LinkAddress, 6);
 
@@ -2612,14 +2625,14 @@ Ip6ProcessRedirect (
       if ((NeighborCache->State == EfiNeighborInComplete) || (Result != 0)) {
         CopyMem (&NeighborCache->LinkAddress, LinkLayerOption->EtherAddr, 6);
 
-        NeighborCache->Ticks = (UINT32) IP6_INFINIT_LIFETIME;
+        NeighborCache->Ticks = (UINT32)IP6_INFINIT_LIFETIME;
 
         if (NeighborCache->State == EfiNeighborInComplete) {
           //
           // Send queued packets if exist.
           //
           NeighborCache->State = EfiNeighborStale;
-          NeighborCache->CallBack ((VOID *) NeighborCache);
+          NeighborCache->CallBack ((VOID *)NeighborCache);
         } else {
           NeighborCache->State = EfiNeighborStale;
         }
@@ -2627,7 +2640,7 @@ Ip6ProcessRedirect (
     }
   }
 
-  if (NeighborCache != NULL && IsRouter) {
+  if ((NeighborCache != NULL) && IsRouter) {
     //
     // The Target is a router, set IsRouter to TRUE.
     //
@@ -2667,14 +2680,14 @@ Exit:
 **/
 EFI_STATUS
 Ip6AddNeighbor (
-  IN IP6_SERVICE            *IpSb,
-  IN EFI_IPv6_ADDRESS       *TargetIp6Address,
-  IN EFI_MAC_ADDRESS        *TargetLinkAddress OPTIONAL,
-  IN UINT32                 Timeout,
-  IN BOOLEAN                Override
+  IN IP6_SERVICE       *IpSb,
+  IN EFI_IPv6_ADDRESS  *TargetIp6Address,
+  IN EFI_MAC_ADDRESS   *TargetLinkAddress OPTIONAL,
+  IN UINT32            Timeout,
+  IN BOOLEAN           Override
   )
 {
-  IP6_NEIGHBOR_ENTRY        *Neighbor;
+  IP6_NEIGHBOR_ENTRY  *Neighbor;
 
   Neighbor = Ip6FindNeighborEntry (IpSb, TargetIp6Address);
   if (Neighbor != NULL) {
@@ -2702,7 +2715,7 @@ Ip6AddNeighbor (
     Neighbor->Ticks   = IP6_GET_TICKS (Timeout / TICKS_PER_MS);
     Neighbor->Dynamic = TRUE;
   } else {
-    Neighbor->Ticks   = (UINT32) IP6_INFINIT_LIFETIME;
+    Neighbor->Ticks = (UINT32)IP6_INFINIT_LIFETIME;
   }
 
   return EFI_SUCCESS;
@@ -2729,14 +2742,14 @@ Ip6AddNeighbor (
 **/
 EFI_STATUS
 Ip6DelNeighbor (
-  IN IP6_SERVICE            *IpSb,
-  IN EFI_IPv6_ADDRESS       *TargetIp6Address,
-  IN EFI_MAC_ADDRESS        *TargetLinkAddress OPTIONAL,
-  IN UINT32                 Timeout,
-  IN BOOLEAN                Override
+  IN IP6_SERVICE       *IpSb,
+  IN EFI_IPv6_ADDRESS  *TargetIp6Address,
+  IN EFI_MAC_ADDRESS   *TargetLinkAddress OPTIONAL,
+  IN UINT32            Timeout,
+  IN BOOLEAN           Override
   )
 {
-  IP6_NEIGHBOR_ENTRY        *Neighbor;
+  IP6_NEIGHBOR_ENTRY  *Neighbor;
 
   Neighbor = Ip6FindNeighborEntry (IpSb, TargetIp6Address);
   if (Neighbor == NULL) {
@@ -2761,24 +2774,24 @@ Ip6DelNeighbor (
 VOID
 EFIAPI
 Ip6NdFasterTimerTicking (
-  IN EFI_EVENT              Event,
-  IN VOID                   *Context
+  IN EFI_EVENT  Event,
+  IN VOID       *Context
   )
 {
-  LIST_ENTRY                *Entry;
-  LIST_ENTRY                *Next;
-  LIST_ENTRY                *Entry2;
-  IP6_INTERFACE             *IpIf;
-  IP6_DELAY_JOIN_LIST       *DelayNode;
-  EFI_IPv6_ADDRESS          Source;
-  IP6_DAD_ENTRY             *DupAddrDetect;
-  EFI_STATUS                Status;
-  IP6_NEIGHBOR_ENTRY        *NeighborCache;
-  EFI_IPv6_ADDRESS          Destination;
-  IP6_SERVICE               *IpSb;
-  BOOLEAN                   Flag;
-
-  IpSb = (IP6_SERVICE *) Context;
+  LIST_ENTRY           *Entry;
+  LIST_ENTRY           *Next;
+  LIST_ENTRY           *Entry2;
+  IP6_INTERFACE        *IpIf;
+  IP6_DELAY_JOIN_LIST  *DelayNode;
+  EFI_IPv6_ADDRESS     Source;
+  IP6_DAD_ENTRY        *DupAddrDetect;
+  EFI_STATUS           Status;
+  IP6_NEIGHBOR_ENTRY   *NeighborCache;
+  EFI_IPv6_ADDRESS     Destination;
+  IP6_SERVICE          *IpSb;
+  BOOLEAN              Flag;
+
+  IpSb = (IP6_SERVICE *)Context;
   NET_CHECK_SIGNATURE (IpSb, IP6_SERVICE_SIGNATURE);
 
   ZeroMem (&Source, sizeof (EFI_IPv6_ADDRESS));
@@ -2790,13 +2803,14 @@ Ip6NdFasterTimerTicking (
   //
   if ((IpSb->Ip6ConfigInstance.Policy == Ip6ConfigPolicyAutomatic) &&
       !IpSb->RouterAdvertiseReceived &&
-      IpSb->SolicitTimer > 0
-      ) {
+      (IpSb->SolicitTimer > 0)
+      )
+  {
     if ((IpSb->Ticks == 0) || (--IpSb->Ticks == 0)) {
       Status = Ip6SendRouterSolicit (IpSb, NULL, NULL, NULL, NULL);
       if (!EFI_ERROR (Status)) {
         IpSb->SolicitTimer--;
-        IpSb->Ticks = (UINT32) IP6_GET_TICKS (IP6_RTR_SOLICITATION_INTERVAL);
+        IpSb->Ticks = (UINT32)IP6_GET_TICKS (IP6_RTR_SOLICITATION_INTERVAL);
       }
     }
   }
@@ -2864,7 +2878,8 @@ Ip6NdFasterTimerTicking (
           //
           Flag = FALSE;
           if ((DupAddrDetect->Receive == 0) ||
-              (DupAddrDetect->Transmit <= DupAddrDetect->Receive)) {
+              (DupAddrDetect->Transmit <= DupAddrDetect->Receive))
+          {
             Flag = TRUE;
           }
 
